<?
define("UDP_IKA_PORT",12080);
define("UDP_IKA_VERSION",1);
define("IKAP_STARTBYTE",0xa5);

define("IKAP_BROADCAST","\0\0\0\0");

// Encoding types
define("IKAP_ENC_CLEAR",0x00);
define("IKAP_ENC_XTEA",0x01);
define("IKAP_ENC_XTEA_CBC",0x02);
define("IKAP_ENC_XXTEA",0x03);
define("IKAP_ENC_ARCFOUR",0x04);
define("IKAP_ENC_AES128",0x05);
define("IKAP_ENC_AES256",0x06);



// Message Type
define("IKAP_MSG_NULL",0x00);
define("IKAP_MSG_REQUEST",0x01);
define("IKAP_MSG_ACTION",0x02);
define("IKAP_MSG_ACK",0x03);
define("IKAP_MSG_NOTIFY",0x04);
define("IKAP_MSG_NOTIFYCONF",0x05);
define("IKAP_MSG_REQUESTCONF",0x06);
define("IKAP_MSG_SETCONF",0x07);
define("IKAP_MSG_DEBUG",0xff);

// Context
define("IKAP_CTX_NULL",0x0000);
define("IKAP_CTX_LIGHT",0x0001);
define("IKAP_CTX_SOCKET",0x0002);
define("IKAP_CTX_BLIND",0x0003);
define("IKAP_CTX_SENSOR",0x0004);
define("IKAP_CTX_DOOR",0x0005);
define("IKAP_CTX_WINDOW",0x0006);
define("IKAP_CTX_VALVE",0x0007);
define("IKAP_CTX_STATUS",0x0008);
define("IKAP_CTX_SCENARY",0x0009);
define("IKAP_CTX_ALARM",0x000a);
define("IKAP_CTX_CITOPHONE",0x000b);
define("IKAP_CTX_GENERIC_SWITCH",0x000c);
define("IKAP_CTX_TERMOSTAT",0x000d);
define("IKAP_CTX_GATE",0x000e);
define("IKAP_CTX_AUDIO",0x000f);
define("IKAP_CTX_VIDEO",0x0010);
define("IKAP_CTX_PHONE",0x0011);
define("IKAP_CTX_TV",0x0012);
define("IKAP_CTX_IRRIGATION",0x0013);
define("IKAP_CTX_TIMER",0x0014);
define("IKAP_CTX_INTERNET",0x0015);
define("IKAP_CTX_MESSAGE",0x0016);
define("IKAP_CTX_RFID",0x0017);
define("IKAP_CTX_PUMP",0x0018);
define("IKAP_CTX_MOTOR",0x0019);
define("IKAP_CTX_RTC",0x0020);
define("IKAP_CTX_SYSTEM",0xfffe);
define("IKAP_CTX_USER",0xffff);

//Actions
define("IKAP_ACT_NULL",0x00);
define("IKAP_ACT_ON",0x01);
define("IKAP_ACT_OFF",0x02);
define("IKAP_ACT_CHANGE",0x03);
define("IKAP_ACT_OPEN",0x04);
define("IKAP_ACT_CLOSE",0x05);
define("IKAP_ACT_UP",0x06);
define("IKAP_ACT_DOWN",0x07);
define("IKAP_ACT_STOP",0x08);
define("IKAP_ACT_START",0x09);
define("IKAP_ACT_STOPTIMERED",0x0a);
define("IKAP_ACT_STARTTIMERED",0x0b);
define("IKAP_ACT_BLOCKUNBLOCK",0x0c);
define("IKAP_ACT_BLOCK",0x0d);
define("IKAP_ACT_UNBLOCK",0x0e);
define("IKAP_ACT_HI",0x0f);
define("IKAP_ACT_LOW",0x10);
define("IKAP_ACT_EQUAL",0x11);
define("IKAP_ACT_EXPIRED",0x12);
define("IKAP_ACT_TIMEDOUT",0x13);
define("IKAP_ACT_CHANGED",0x14);
define("IKAP_ACT_SWITCHEDON",0x15);
define("IKAP_ACT_SWITCHEDOFF",0x16);
define("IKAP_ACT_CALL",0x17);
define("IKAP_ACT_ANSWER",0x18);
define("IKAP_ACT_RING",0x19);
define("IKAP_ACT_PLAY",0x1a);
define("IKAP_ACT_PAUSE",0x1b);

define("IKAP_ACT_BOARD",0xfd);
define("IKAP_ACT_DEBUG",0xff);


define("DM_OUTPUT_TYPE_NULL",0x00);
define("DM_OUTPUT_TYPE_ONOFF",0x01);
define("DM_OUTPUT_TYPE_IMPULSO",0x02);
define("DM_OUTPUT_TYPE_TEMPORIZZATA",0x03);
define("DM_OUTPUT_TYPE_INTERMITTENTE",0x04);
define("DM_OUTPUT_TYPE_INTERMITTENTE_TEMPORIZZATA",0x05);
define("DM_OUTPUT_TYPE_SIGNALING",0x06);
define("DM_OUTPUT_TYPE_PWM",0x07);
define("DM_OUTPUT_TYPE_DIMMER",0x08);
define("DM_OUTPUT_TYPE_2_RELAY_EXCLUSIVE",0xf0);
define("DM_OUTPUT_TYPE_2_RELAY_INCLUSIVE_ON",0xf1);
define("DM_OUTPUT_TYPE_2_RELAY_INCLUSIVE_OFF",0xf2);
define("DM_OUTPUT_TYPE_2_RELAY_ALTERNATE_SEQ",0xf3);
define("DM_OUTPUT_TYPE_OPEN_CLOSE_2_RELAYS",0xf4);
define("DM_OUTPUT_TYPE_RGB",0xfa);
define("DM_OUTPUT_TYPE_SEQUENZA",0xff);



define("SEQUENCE_TYPE_NULL",0x00);
define("SEQUENCE_TYPE_CONTINUE",0x01);
define("SEQUENCE_TYPE_RANDOM",0x02);
define("SEQUENCE_TYPE_CYCLE",0x03);
define("SEQUENCE_TYPE_CONTINUE_RANDOM",0x04);
define("SEQUENCE_TYPE_CYCLE_RANDOM",0x05);


define("VIDEO_TYPE_NULL",0x00);
define("VIDEO_TYPE_IPCAM",0x01);


define("MOTION_STATUS_START",0x01);
define("MOTION_STATUS_UPDATE",0x02);
define("MOTION_STATUS_STOP",0x03);
define("MOTION_STATUS_ALL",0xff);

define("MOTION_TYPE_MOTION",0x01);

define("DM_INPUT_TYPE_DIGITAL",0xff);

define("DM_RELAY_ON", 1);
define("DM_RELAY_OFF", 0);
define("DM_INPUT_CLOSED", 1);
define("DM_INPUT_OPEN", 0);

define("BOARD_MODULE_NONE",0x00);
define("BOARD_MODULE_97j60",0x01);
define("BOARD_MODULE_67j60M",0x02);
define("BOARD_MODULE_67j60S",0x03);
define("BOARD_MODULE_67j60_Wifi",0x04);
define("BOARD_MODULE_97j60_Wifi",0x05);
define("BOARD_MODULE_2620",0x06);
define("BOARD_MODULE_2685",0x07);

define("BOARD_WORKER_12R12I_v1",0x0001);
define("BOARD_WORKER_12R12I_v3",0x0002);
define("BOARD_WORKER_RFID",0x0003);
define("BOARD_WORKER_DIMMER",0x0004);
define("BOARD_WORKER_SENSORS",0x0005);
define("BOARD_WORKER_GW",0x0006);
define("BOARD_WORKER_RGBLED",0x0007);
define("BOARD_WORKER_DMSNT84",0x0008);

define("FWTYPE_IRRIGAZIONE",0x01);
define("FWTYPE_RELAYMASTER",0x02);
define("FWTYPE_CANCELLI",0x03);
define("FWTYPE_1TO1",0x04);
define("FWTYPE_ALARM",0x05);
define("FWTYPE_LIGHT",0x06);
define("FWTYPE_TAPPARELLE",0x07);
define("FWTYPE_DMLED",0x08);
define("FWTYPE_TESTDMR3",0xff);


?>
